%{
(* Copyright (c) 2003 Michal Moskal <malekith@pld-linux.org>
   Licensed under the Academic Free License version 2.0 *)

let intize s =
  try
    int_of_string s
  with Failure _ -> 0

let boolize s =
  try
    int_of_string s == 0
  with Failure _ -> true
  
%}

%token <string> VAL
%token OR AND NOT
%token LE GE LT GT EQ NE
%token L_PAREN R_PAREN EOF

%left OR
%left AND
%left EQ NE
%left LE GE LT GT
%nonassoc NOT

%start texpr
%type <bool> texpr

%%

texpr: expr EOF { $1 }

expr:
          expr OR expr       { $1 || $3 }
        | expr AND expr      { $1 && $3 }
        | NOT expr           { not $2 }
        | VAL EQ VAL         { $1 = $3 }
        | VAL NE VAL         { $1 <> $3 }
        | VAL LE VAL         { intize $1 <= intize $3 }
        | VAL GE VAL         { intize $1 >= intize $3 }
        | VAL LT VAL         { intize $1 < intize $3 }
        | VAL GT VAL         { intize $1 > intize $3 }
        | VAL                { boolize $1 }
        | L_PAREN expr R_PAREN { $2 }
